﻿'INSTANT C# NOTE: Formerly VB.NET project-level imports:

Imports Microsoft.VisualBasic
Imports System
Imports System.Collections
Imports System.Collections.Generic
Imports System.Data
Imports System.Drawing
Imports System.Diagnostics
Imports System.Windows.Forms
Imports System.Linq
Imports System.Xml.Linq
Imports Syncfusion.Windows.Forms.Grid

Namespace SF_GridControl_ComboBox_CopyPaste
	Partial Public Class Form1
		Friend Sub New()
			InitializeComponent()
		End Sub
		Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
			Dim comboBox As New DataTable()
			comboBox.Columns.Add(New DataColumn("Value", Type.GetType("System.String")))
			comboBox.Columns.Add(New DataColumn("Display", Type.GetType("System.String")))
			Dim dr As DataRow = Nothing
			dr = comboBox.NewRow()
			dr("Value") = "1"
			dr("Display") = "One"
			comboBox.Rows.Add(dr)
			dr = comboBox.NewRow()
			dr("Value") = "2"
			dr("Display") = "Two"
			comboBox.Rows.Add(dr)
			dr = comboBox.NewRow()
			dr("Value") = "3"
			dr("Display") = "Three"
			comboBox.Rows.Add(dr)
			dr = comboBox.NewRow()
			dr("Value") = "4"
			dr("Display") = "Four"
			comboBox.Rows.Add(dr)

			Me.GridControl1.ColStyles(1).DataSource = comboBox
			Me.GridControl1.ColStyles(1).DisplayMember = "Display"
			Me.GridControl1.ColStyles(1).ValueMember = "Value"

			AddHandler GridControl1.Model.ClipboardCanPaste, AddressOf Model_ClipboardCanPaste
		End Sub
		Private copran As GridRangeInfo
		Private Sub Model_ClipboardCanPaste(ByVal sender As Object, ByVal e As Syncfusion.Windows.Forms.Grid.GridCutPasteEventArgs)
			Dim dataObject As IDataObject = Clipboard.GetDataObject()
			If dataObject IsNot Nothing Then
				Dim s As String = CType(dataObject.GetData(DataFormats.Text), String)
				copran = Me.GridControl1.Selections.Ranges.ActiveRange
				For i As Integer = copran.Top To copran.Bottom
					For j As Integer = copran.Left To copran.Right
						Me.GridControl1.Model(i, j).ApplyText(s)
					Next j
				Next i
			End If
			e.Handled = True
			e.Result = False
		End Sub
	End Class

End Namespace 'end of root namespace